VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cLib"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"

' Orginal [cCDECL]

Option Explicit
Option Base 0

Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function LoadLibraryA Lib "kernel32" (ByVal lpLibFileName As String) As Long
Private Declare Function VirtualAlloc Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Private Declare Function VirtualFree Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long

Private Declare Sub GetMem4 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Long)
Private Declare Sub PutMem1 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Byte)
Private Declare Sub PutMem2 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Integer)
Private Declare Sub PutMem4 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Long)
Private Declare Sub PutMem8 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Currency)
Private Declare Sub SetLastError Lib "kernel32" (ByVal dwErrCode As Long)

Private Const ERR_SRC       As String = "cCDECL"    'Error source name
Private Const ERR_NUM       As Long = vbObjectError 'cCDECL error number base
Private Const MAX_ARG       As Long = 16            'Maximum number of parameters, you can change this if required
Private Const PATCH_01      As Long = 15            'CDECL patch, CDECL function address
Private Const PATCH_02      As Long = 10            'Callback patch, bas mod function address patch
Private Const PATCH_03      As Long = 16            'Callback patch, stack adjustment patch

Private Type tParamBlock
  ParamCount                As Long                 'Number of parameters to be forwarded to the cdecl function
  Params(0 To MAX_ARG - 1)  As Long                 'Array of parameters to be forwarded to the cdecl function
End Type

Private m_LastError         As Long
Private hMod                As Long
Private nAddr               As Long
Private pCode               As Long
Private sLastFunc           As String
Private Pb                  As tParamBlock

Private Sub Class_Initialize()
Dim pMe As Long

    GetMem4 ObjPtr(Me), pMe
    pCode = VirtualAlloc(0, &H1000&, &H1000&, &H40&)
  
    PutMem8 pCode + 0, -208642111809017.9757@
    PutMem8 pCode + 8, -605931634821031.5515@
    PutMem8 pCode + 16, 20765931315670.1386@
    PutMem8 pCode + 24, -857143604525899.4687@
    PutMem4 pCode + 32, &HC2C03102
    PutMem2 pCode + 36, &HC

    PutMem4 pMe + &H1C, pCode
  
    PutMem8 pCode + 40, 479615108421936.7656@
    PutMem8 pCode + 48, -140483859888551.3191@
    PutMem8 pCode + 56, 99649511.6971@
    PutMem8 pCode + 64, 21442817159.0144@
End Sub

Private Sub Class_Terminate()
    Call DllUnload
    VirtualFree pCode, 0, &H8000&
End Sub

Public Function z_DO_NOT_CALL(ByVal nAddrParamBlock As Long) As Long
End Function
Public Function Func(ByVal sFunction As String, ParamArray ParmLongs() As Variant) As Long
Dim i As Long
Dim j As Long
  
    If hMod = 0 Then
        Call Err.Raise(ERR_NUM + 0, ERR_SRC, "DLL not loaded")
        Exit Function
    End If

    If (StrComp(sLastFunc, sFunction) <> 0) Then
    
        nAddr = GetProcAddress(hMod, sFunction)
        If nAddr = 0 Then
            Debug.Assert False
            Call Err.Raise(ERR_NUM + 1, ERR_SRC, "Failed to locate function: " & sFunction)
        End If
        
        PutMem4 pCode + PATCH_01, nAddr - pCode - (PATCH_01 + 4)
        sLastFunc = sFunction
    End If
  
    With Pb
        j = UBound(ParmLongs)
        If j >= MAX_ARG Then
            Debug.Assert False
            Call Err.Raise(ERR_NUM + 2, ERR_SRC, "Too many parameters")
        End If
        For i = 0 To j
            .Params(i) = ParmLongs(i)
        Next i
        .ParamCount = i
    End With
  
    Call SetLastError(0)                                     'Clear the error code
    Func = z_DO_NOT_CALL(VarPtr(Pb))                         'Execute the code buffer passing the address of the parameter block
    m_LastError = GetLastError()                             'Get error code
End Function
Public Function DllLoad(ByVal sName As String) As Boolean
    If hMod <> 0 Then DllUnload
    hMod = LoadLibraryA(sName)
    If hMod <> 0 Then
        DllLoad = True
        sLastFunc = ""
    End If
    'Debug.Assert DllLoad
End Function
Public Function DllUnload() As Boolean
    If hMod <> 0 Then
        DllUnload = (FreeLibrary(hMod) <> 0)
        If DllUnload Then hMod = 0
    End If
End Function
Property Get LastError() As Long: LastError = m_LastError: End Property
Property Get Handle() As Long: Handle = hMod: End Property
Public Function WrapCallback(ByVal nModFuncAddr As Long, ByVal nParms As Long) As Long
Dim nStackAdjust As Long
    WrapCallback = pCode + 40
    nStackAdjust = nParms * 4
    PutMem4 WrapCallback + PATCH_02, nModFuncAddr - WrapCallback - (PATCH_02 + 4)
    PutMem4 WrapCallback + PATCH_03, nStackAdjust
End Function
