VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSqliteCursor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'Autor          : J. Elihu
'----------------------------------------------------
'Version        : 1.6
'Date           : 14/12/20

'Requirements   :
'               - cLib
'               - cSqlite
'Credits        :
'               - Cobein   (mSqlite)
'               - Cocus    (cSQLiteRecordset)

Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)
Private Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByRef lpMultiByteStr As Any, ByVal cchMultiByte As Long, ByVal lpDefaultChar As String, ByVal lpUsedDefaultChar As Long) As Long
Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenW" (ByVal lpString As Long) As Long
Private Declare Function lstrlenA Lib "kernel32" (ByVal lpString As Long) As Long

'/ Destructor Type
Private Const SQLITE_STATIC     As Long = 0
Private Const SQLITE_TRANSIENT  As Long = -1

'/ Fundamental DataTypes
Public Enum enmSqlite3Data
    [Sql3Int] = 1
    [Sql3Float] = 2
    [Sql3Text] = 3
    [Sql3Blob] = 4
    [Sql3Null] = 5
End Enum

Private Type tDataBlob
    lPtr    As Long
    lSize   As Long
End Type

Private pSqlite3    As Long
Private pStmt3      As Long

Private moFields    As Collection       ' -> Quick Access
Private m_Count     As Long

Private Sub Class_Initialize()
    Set moFields = New Collection
End Sub
Private Sub Class_Terminate()
    Call Unlink
End Sub

Friend Function Link(ByVal ppStmt As Long, ByVal ppSqlite3 As Long) As Boolean
Dim i As Long

    Call Unlink
    pSqlite3 = ppSqlite3  ' oSql3_dll.Func("sqlite3_db_handle", ppStmt)
    pStmt3 = ppStmt
    m_Count = oSql3_dll.Func("sqlite3_column_count", pStmt3)
    
    For i = 0 To m_Count - 1: put_to_collection Me.FieldName(i), i, Me.FieldName(i): Next
    
End Function

Friend Function Unlink() As Sqlite3Result
On Error Resume Next

    If pStmt3 <> 0 Then
        Unlink = oSql3_dll.Func("sqlite3_finalize", pStmt3)
        If Unlink = SQLITE_OK Then pStmt3 = 0 Else Exit Function
    End If
    
    pSqlite3 = 0
    Set moFields = Nothing
    
End Function

Public Function Reset() As Sqlite3Result
    Reset = oSql3_dll.Func("sqlite3_reset", pStmt3)
End Function
Public Function Step() As Sqlite3Result
    Step = oSql3_dll.Func("sqlite3_step", pStmt3)
End Function

Property Get Value(ByVal Index As String, Optional DataType As enmSqlite3Data = 3) As String
On Error GoTo e
Dim bvData() As Byte
Dim eData    As tDataBlob

    If Not IsNumeric(Index) Then Index = LookupField(Index)
    If (Index < 0) Or (Index > m_Count - 1) Then Exit Property
    
    If DataType = 5 Then Exit Property '-> Null
    Select Case DataType
        Case 1 '-> Int
            Value = oSql3_dll.Func("sqlite3_column_int", pStmt3, Index)
            Exit Property
        'Case 2 '-> Float
        Case 4 '-> Blob
            eData.lPtr = oSql3_dll.Func("sqlite3_column_blob", pStmt3, Index)
            eData.lSize = oSql3_dll.Func("sqlite3_column_bytes", pStmt3, Index)
        Case 5 '-> Null
        Case Else '->3 Text
            eData.lPtr = oSql3_dll.Func("sqlite3_column_text16", pStmt3, Index)
            eData.lSize = oSql3_dll.Func("sqlite3_column_bytes16", pStmt3, Index)
    End Select
    
    ReDim bvData(eData.lSize - 1)
    CopyMemory bvData(0), ByVal eData.lPtr, eData.lSize - 1
    Value = bvData
e:
End Property

Property Get Blob(ByVal Index As Long) As Byte()
Dim eData As tDataBlob
    eData.lPtr = oSql3_dll.Func("sqlite3_column_blob", pStmt3, Index)
    eData.lSize = oSql3_dll.Func("sqlite3_column_bytes", pStmt3, Index)
    Blob = BytesFromPtr(eData.lPtr, eData.lSize)
End Property

Property Get Sql() As String
    Sql = StringFromPtr(oSql3_dll.Func("sqlite3_sql", pStmt3))
End Property
Property Get Table() As String
    Table = StringFromPtr(oSql3_dll.Func("sqlite3_column_table_name", pStmt3, 0))
End Property
Property Get FieldCount() As Long
    FieldCount = oSql3_dll.Func("sqlite3_column_count", pStmt3)
End Property
Property Get FieldName(ByVal Index As Long) As String
    FieldName = StringFromPtr(oSql3_dll.Func("sqlite3_column_name", pStmt3, Index))
End Property
Public Function LastInsertID() As Long
    LastInsertID = oSql3_dll.Func("sqlite3_last_insert_rowid", pSqlite3)
End Function

'/ Sqlite3 binding
Public Function ClearBindings() As Sqlite3Result
    ClearBindings = oSql3_dll.Func("sqlite3_clear_bindings", pStmt3)
End Function

Property Get BindCount() As Long
    BindCount = oSql3_dll.Func("sqlite3_bind_parameter_count", pStmt3)
End Property

Property Get BindName(ByVal Index As Long) As String
    BindName = StringFromPtr(oSql3_dll.Func("sqlite3_bind_parameter_name", pStmt3, Index))
End Property

Property Get BindIndex(ByVal zName As String) As Long
Dim bvStr() As Byte
    If Left(zName, 1) <> ":" Then zName = ":" & zName
    bvStr = StrConv(zName & vbNullChar, vbFromUnicode)
    BindIndex = oSql3_dll.Func("sqlite3_bind_parameter_index", pStmt3, VarPtr(bvStr(0)))
End Property

Public Function Bind(ByVal Index As String, Value As Variant, Optional Bind3 As enmSqlite3Data = 3) As Sqlite3Result
On Error Resume Next
Dim pbData() As Byte

    If Not IsNumeric(Index) Then
        If Left(Index, 1) <> ":" Then Index = ":" & Index
        Index = BindIndex(Index)
    End If

    Select Case Bind3
        Case 1 '-> Int
            Bind = oSql3_dll.Func("sqlite3_bind_int", pStmt3, Index, Value)
        Case 4 '-> Blob
            pbData = Value
            Bind = oSql3_dll.Func("sqlite3_bind_blob", pStmt3, Index, VarPtr(pbData(0)), UBound(pbData), SQLITE_TRANSIENT)
        Case 5 '-> Null
            Bind = oSql3_dll.Func("sqlite3_bind_null", pStmt3, Index)
        Case Else '-> Text
            pbData = ppString(CStr(Value))
            Bind = oSql3_dll.Func("sqlite3_bind_text", pStmt3, Index, VarPtr(pbData(0)), -1, SQLITE_TRANSIENT)
    End Select
End Function


'Private Function bind_text16(ByVal Index As Long, ByVal Value As String) As Sqlite3Result
'Dim bvStr() As Byte
'
'    Value = UnicodeToUTF16(Value & vbNullChar)
'    bvStr = Value
'    bind_text16 = oSql3_dll.Func("sqlite3_bind_text16", pStmt3, Index, VarPtr(bvStr(0)), -1, SQLITE_TRANSIENT)
'
'End Function



'/ Private Subs
Private Property Get OriginName(ByVal Index As Long) As String
    OriginName = StringFromPtr(oSql3_dll.Func("sqlite3_column_origin_name", pStmt3, Index))
End Property
Private Property Get DataBaseName() As String
    DataBaseName = StringFromPtr(oSql3_dll.Func("sqlite3_column_database_name", pStmt3, 0))
End Property
Private Property Get DefaultDataType(ByVal Index As Long) As Long
    DefaultDataType = oSql3_dll.Func("sqlite3_column_type", pStmt3, Index)
End Property
Private Function LookupField(ByVal ColumnName As String) As Long
On Error GoTo e
    LookupField = -1
    LookupField = moFields(ColumnName)(0)
e:
End Function

Private Sub put_to_collection(ByVal Key As String, ParamArray elements() As Variant)
On Error GoTo e
    
    If moFields Is Nothing Then Set moFields = New Collection
    remove_from_collection Key
    moFields.Add elements, Key
e:  Err.Clear
End Sub
Private Sub remove_from_collection(ByVal Key As String)
On Error GoTo e
    moFields.Remove Key
e:  Err.Clear
End Sub

Private Function ColText(ByVal Stmt As Long, ByVal Col As Long) As String
Dim eData As tDataBlob
    
    '\Normal text
    'eData.lPtr = oSql3_dll.Func("sqlite3_column_text", Stmt, Col)
    'eData.lSize = oSql3_dll.Func("sqlite3_column_bytes", Stmt, Col)
    'ColText = StringFromPtr(eData.lPtr, eData.lSize)
    
    eData.lPtr = oSql3_dll.Func("sqlite3_column_text16", Stmt, Col)
    eData.lSize = oSql3_dll.Func("sqlite3_column_bytes16", Stmt, Col)
    ColText = BytesFromPtr(eData.lPtr, eData.lSize)

End Function
Private Function ppString(Data As String) As Byte()
    ppString = StrConv(UnicodeToUTF8(Data) & vbNullChar, vbFromUnicode)
End Function
Private Function StringFromPtr(Ptr As Long, Optional ByVal Size As Long = -1) As String
Dim pzLen   As Long

    If Ptr = 0 Then Exit Function
    If Size = -1 Then Size = lstrlenA(Ptr)
    If Not Size > 0 Then Exit Function
    pzLen = MultiByteToWideChar(65001, 0, Ptr, Size, 0, 0)
    If Not pzLen > 0 Then Exit Function

    StringFromPtr = Space$(pzLen)
    MultiByteToWideChar 65001, 0, Ptr, Size, StrPtr(StringFromPtr), pzLen
    
End Function

Private Function BytesFromPtr(ByVal lAddr As Long, ByVal lSize As Long) As Byte()
On Error GoTo Err
Dim bvData() As Byte
    ReDim bvData(lSize - 1)
    CopyMemory bvData(0), ByVal lAddr, lSize - 1
    BytesFromPtr = bvData
Err:
End Function

Private Function UnicodeToUTF8(ByVal sData As String) As String
Dim bvData()    As Byte
Dim lSize       As Long
Dim lRet        As Long
    If LenB(sData) Then
        lSize = Len(sData) * 4
        ReDim bvData(lSize)
        lRet = WideCharToMultiByte(65001, 0, StrPtr(sData), Len(sData), bvData(0), lSize + 1, vbNullString, 0)
        If lRet Then
            ReDim Preserve bvData(lRet - 1)
            UnicodeToUTF8 = StrConv(bvData, vbUnicode)
        End If
    End If
End Function

Private Function UnicodeToUTF16(ByVal sData As String) As String
Dim bvData()    As Byte
Dim lSize       As Long
Dim lRet        As Long
    If LenB(sData) Then
        sData = UnicodeToUTF8(sData)
        lSize = Len(sData)
        ReDim bvData(lSize)
        lRet = MultiByteToWideChar(65001, 0, StrPtr(sData), Len(sData), bvData(0), lSize + 1)
        If lRet Then
            ReDim Preserve bvData(lRet - 1)
            UnicodeToUTF16 = StrConv(bvData, vbUnicode)
        End If
    End If
End Function

